!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!! Class Definition File Contents
!!!!! File Name: CstrClass.clw
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

              MEMBER
              MAP
                Module('Window API')
                cstr_Memmove(Ulong Dest,Ulong Src,Ulong Size),Name('_memmove')
                cstr_MultiByteToWideChar(Unsigned Codepage,Ulong dwFlags,ULong LpMultuByteStr, |
                    Long cbMultiByte, ULong LpWideCharStr,Long cchWideChar),RAW,Ulong,PASCAL,NAME('MultiByteToWideChar')
                cstr_WideCharToMultiByte(Unsigned Codepage,Ulong dwFlags,ULong LpWideCharStr,Long cchWideChar, |
                    ULong lpMultuByteStr, Long cbMultiByte, Ulong LpDefalutChar,Ulong lpUsedDefalutChar), |
                    Raw,Ulong,Pascal,NAME('WideCharToMultiByte')
                End
              END
              INCLUDE('CStrClass.inc'),ONCE

Cstr.Construct Procedure()
               Code
               Self.S &= New CString(2)
               Self.S = ''
               Self.Len=0
               Return

Cstr.Destruct  Procedure()
               Code
               !Stop('Destruct!')
               If ~(Self.S &= Null)
                 Dispose(Self.S)
                 Self.S &= Null
                 Self.Len=0
               End
               Return

Cstr.Empty     Procedure(Long L)
               Code
               If L=0
                 Self.Len=0
               Else
                 Self.Set(All(' ',L))
               End
               Return


Cstr.Cat       Procedure(String P)
L              Long
NewStr         &CString
               Code
               L=Len(P)
               NewStr &=  New CString(Self.Len+L+1)
               cstr_MemMove(Address(NewStr),Address(Self.S),Self.Len)
               cstr_MemMove(Address(NewStr)+Self.Len,Address(P),L)
               NewStr[Self.Len+L+1]='<0>'
               Dispose(Self.S)
               Self.S &= NewStr
               Self.Len+=L
               Return Self

Cstr.Cat       Procedure(*CString P)
L              Long
NewStr         &CString
               Code
               L=Len(P)
               NewStr &=  New CString(Self.Len+L+1)
               cstr_MemMove(Address(NewStr),Address(Self.S),Self.Len)
               cstr_MemMove(Address(NewStr)+Self.Len,Address(P),L)
               NewStr[Self.Len+L+1]='<0>'
               Dispose(Self.S)
               Self.S &= NewStr
               Self.Len+=L
               Return Self

Cstr.Len       Procedure()
               Code
               Return(Self.Len)

Cstr.Str       Procedure
               Code
               Return Self.S[1 : Self.Len]

Cstr.CStr      Procedure()
               Code
               Return Self.S

Cstr.Set       Procedure(String S)
               Code
               Self.Len=Len(S)
               Dispose(Self.S)
               Self.S &= New CString(Self.Len+1)
               cstr_Memmove(Address(Self.S),Address(S),Self.Len)
               Self.S[Self.Len+1]='<0>'
               Return

Cstr.Set       Procedure(*CString CS)
L              Long
NewStr         &String
               Code
               Self.Len=Len(CS)
               Dispose(Self.S)
               Self.S &= New CString(Self.Len+1)
               Self.S=CS
               Return

Cstr.Sub       Procedure(Long From,<Long L>)
               Code
               If ~Omitted(L)
                 IF From > Self.Len
                   Return Self.S[1:0]
                 END
                 IF L <= Self.Len
                   Return Self.S[From : L]
                 Else
                   Return Self.S[From : Self.Len]
                 End
               Else
                 Return Self.S[From : Self.Len]
               End

Cstr.Slice     Procedure(Long F,Long T)
               Code
               Return Self.S[F : T]

Cstr.LoadFromBlob Procedure(*Blob B)
L                 Long
                  Code
                  L=B{Prop:Size}
                  If L>0
                    Self.Set(B[0 : L-1])
                  Else
                    Self.Set('')
                  End
                  Return

Cstr.SaveToBlob   Procedure(*Blob B)
                  Code
                  B{Prop:Size}=Self.Len
                  If Self.Len>0
                    B[0 : Self.Len-1] = Self.Str()
                  End
                  Return

Cstr.Kill         Procedure()
                  Code
                  Dispose(Self)
                  Return

Cstr.LoadFromFile Procedure(String FileName)
Loc:FileName      Cstring(260),Static
In                File,Driver('DOS','/QuickScan=on'),Name(Loc:FileName),Pre(In)
Record            Record
S                 String(10000)
                  End
                  End
Pos               Long
Err               Long
                  Code
                  If Exists(FileName)
                    Loc:FileName=FileName
              Elsif Exists(Lower(FileName))
                    Loc:FileName = Lower(FileName)
                  Else
                    Loc:FileName = FileName
                  End
                  Open(In, 0)
                  If ErrorCode()
                    Return(ErrorCode())
                  End
                  Self.Len=Bytes(In)
                  Dispose(Self.S)
                  Self.S &= New Cstring(Self.Len+1)
                  Self.S[Self.Len+1]='<0>'
                  Set(In)
                  Err=ErrorCode()
                  If Err
                    Close(In)
                    Return(Err)
                  End
                  Loop Pos=1 to Self.Len By Size(In:S)
                     Next(In)
                     Err=ErrorCode()
                     If Err
                       Close(In)
                       Return(Err)
                     End
                     cstr_MemMove(Address(Self.S)+Pos-1,Address(In:S),Bytes(In))
                  End
                  Close(In)
                  Return(0)

Cstr.SaveToFile   Procedure(String FileName)
Loc:FileName      Cstring(260),Static
Out               File,Driver('DOS','/QuickScan=on'),Name(Loc:FileName),Pre(Out),Create
Record            Record
S                 String(10000)
                  End
                  End
Err               Long
RecSize           Long
Pos               Long
                  Code
                  Loc:Filename=lower(FileName)
                  Create(Out)
                  Err=ErrorCode()
                  If Err
                    Return(Err)
                  End
                  Open(Out)
                  Err=ErrorCode()
                  If Err
                    Return(Err)
                  End
                  Loop Pos=1 to Self.Len By Size(Out:S)
                    RecSize=Size(Out:S)
                    If Pos+RecSize>Self.Len+1
                       RecSize=Self.Len-Pos+1
                    End
                    cstr_MemMove(Address(Out:S),Address(Self.S)+Pos-1,RecSize)
                    Add(Out,RecSize)
                    Err=ErrorCode()
                    If Err
                      Close(Out)
                      Return(Err)
                    End
                  End
                  Close(Out)
                  Return(0)

Cstr.Clone        Procedure()
Temp              &Cstr
                  Code
                  Temp &= New Cstr()
                  Temp.Set(Self.S)
                  Return Temp


Cstr.ToUTF8       Procedure() !    UTF8
UnicodeText       &Cstring
UtfText           &CString
L                 Long
                  Code
                  L=Self.Len*2+2
                  UnicodeText &= New CString(L)
                  UTFText &= New CString(L)
                  Clear(UnicodeText,0)
                  If cstr_MultiByteToWideChar(1251,0,Address(Self.S),Self.Len,Address(UnicodeText),L).
                  UnicodeText[ Self.Len*2+1 : Self.Len*2+2] = '<0><0>'
                  L = cstr_WideCharToMultiByte(65001,0,Address(UnicodeText),-1,Address(UTFText),L,0,0)
                  Loop
                    If UtfText[L]='<0>'
                      L-=1
                    Else
                      Break
                    End
                  End
                  Self.Set(UtfText [1 : L])
                  Dispose(UnicodeText)
                  Dispose(UtfText)
                  Return

Cstr.ToASCII      Procedure()
UnicodeText       &string
UtfText           &String
ASCIIText         &CString
Lu                Long
                  Code
                  !      
                  If Self.Len=0
                    Return
                  Elsif Numeric(Self.S)
                    Return
                  End
                  Lu=Self.Len
                  UtfText &= New String(Lu+2)
                  UnicodeText &= New String(Lu*2+2)
                  ASCIIText &= New CString(Lu+2)
                  UtfText=Self.Str()
                  UtfText[Lu+1 : Lu+2]='<0><0>'
                  If cstr_MultiByteToWideChar(65001,0,Address(UTFText),-1,Address(UnicodeText),Lu*2+2).
                  If cstr_WideCharToMultiByte(1251,0,Address(UnicodeText),-1,Address(ASCIIText),Lu+2,0,0).
                  Self.Set(ASCIIText)
                  Dispose(ASCIIText)
                  Dispose(UnicodeText)
                  Dispose(UtfText)
                  Return

Cstr.IndexOf      procedure(STRING substr, LONG nStep = 1, LONG nStart = 1)
    CODE
    return INSTRING(substr,SELF.S,nStep,nStart)

Cstr.Replace      procedure(STRING toReplace, STRING strReplace)
r                 LONG
nStart            LONG
nPos              LONG
nLen              LONG
    CODE
    nStart = 1
    nLen = LEN(toReplace)
    if nLen = 0
      RETURN
    end!
    nPos = SELF.IndexOf(toReplace,1,nStart)
    LOOP WHILE nPos > 0
      if nPos = 1
        SELF.Set(strReplace & SELF.Sub(nLen+1))
      else
        SELF.Set(SELF.Slice(1,nPos-1) & strReplace & SELF.Sub(nPos+nLen))
      end!if
      nStart = nPos + len(strReplace)
      nPos = SELF.IndexOf(toReplace,1,nStart)
    END!loop
